/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package soutez;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.IOException;
import java.net.*;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.*;
import javax.swing.*;

/**
 *
 * @author kajacx
 */
public class MainFrame extends JFrame {

    public static final String server = "192.168.2.76";
    public static final int port = 8010;
    //Container mid = new Container();
    private DlazdicePanel dp = new DlazdicePanel();
    private JTextField zField = new JTextField("3"),
            xField = new JTextField("6"),
            yField = new JTextField("6"),
            moveField = new JTextField("" + dp.moveSpeed); //to string
    private JButton zobraz = new JButton("Zobraz"),
            incrementMove = new JButton("+"),
            decrementMove = new JButton("-");

    public static void main(String[] args) {
        new MainFrame().setVisible(true);
    }

    private MainFrame() {
        super("Kudy Tudy Cestička");
        setLayout(new BorderLayout());
        getContentPane().setBackground(Color.green);


        Container top = new Container();
        top.setLayout(new FlowLayout(FlowLayout.CENTER));

        top.add(new JLabel("Z:"));
        zField.setPreferredSize(new Dimension(50, 20));
        top.add(zField);

        top.add(new JLabel("X:"));
        xField.setPreferredSize(new Dimension(50, 20));
        top.add(xField);

        top.add(new JLabel("Y:"));
        yField.setPreferredSize(new Dimension(50, 20));
        top.add(yField);

        zobraz.addActionListener(new ZobrazActionListener());
        top.add(zobraz);


        Container bot = new Container();
        bot.setLayout(new FlowLayout(FlowLayout.CENTER));

        decrementMove.addActionListener(new IncrementDecrementMoveListener());
        bot.add(decrementMove);

        moveField.setPreferredSize(new Dimension(40, 20));
        moveField.setEditable(false);
        bot.add(moveField);

        incrementMove.addActionListener(new IncrementDecrementMoveListener());
        bot.add(incrementMove);


        add(top, BorderLayout.NORTH);
        add(new JScrollPane(dp), BorderLayout.CENTER);
        add(bot, BorderLayout.SOUTH);
        //add(dp, BorderLayout.CENTER);

        //keyboard imput
        KeyboardFocusManager manager = KeyboardFocusManager.getCurrentKeyboardFocusManager();
        manager.addKeyEventDispatcher(new MyDispatcher());

        pack();
        setSize(getWidth() + 5, getHeight() - 20); //win 8 trolling
        setResizable(false);
        setDefaultCloseOperation(EXIT_ON_CLOSE);
    }

    private void zobrazPressed() {
        int z = Integer.parseInt(zField.getText());
        int x = Integer.parseInt(xField.getText());
        int y = Integer.parseInt(yField.getText());
        dp.zobraz(z, x, y);
    }

    /*private void zobraz(int z, int x, int y) {
        
     }*/
    private class DlazdicePanel extends JPanel {

        private ArrayList<ImageLoader> imageLoaders = new ArrayList<>();
        private Image[][] images = new Image[6][6]; //okolni obrazky jsou take nacteny
        //private boolean[][] loaded = new boolean[6][6]; //je obrazek uz nacteny
        private int velikostDlazdice = 256;
        private int moveSpeed = 16, minSpeed = 1, maxSpeed = 256;
        private int offsetX = 0, offsetY = 0;
        private int centerX, centerY; //possition of "center" kostička :)
        private int currentZ, maxZ = 9, minZ = 0;

        private int stackCurrent = 0, stackMax = 12; //když se načte 12 políček, smaže se pozadí
        
        private Image prezoom; //used for zooming
        private boolean zoomIn;
        
        private DlazdicePanel() {
            setPreferredSize(new Dimension(3 * 256, 3 * 256));
            setBackground(Color.RED);
        }

        public void paintComponent(Graphics g) {
            super.paintComponent(g);
            if(prezoom!=null) {
                if(zoomIn) {
                    g.drawImage(prezoom, 0, 0, velikostDlazdice*3, velikostDlazdice*3,
                            velikostDlazdice, velikostDlazdice, velikostDlazdice*2, velikostDlazdice*2, this);
                } else { //zom out
                    g.drawImage(prezoom, velikostDlazdice, velikostDlazdice, velikostDlazdice*2, velikostDlazdice*2,
                            0, 0, velikostDlazdice*3, velikostDlazdice*3, this);
                }
            }
            for (int i = 0; i < 5; i++) {
                for (int j = 0; j < 5; j++) {
                    if (images[i][j] == null) {
                        continue;
                    }
                    g.drawImage(images[i][j],
                            (i - 1) * velikostDlazdice + offsetX,
                            (j - 1) * velikostDlazdice + offsetY, this);
                    //offsety pro posouvani
                }
            }
        }

        /**
         * draw this jpanel as in img
         * @return 
         */
        private Image paintToImg() {
            BufferedImage img = new BufferedImage(getWidth(), getHeight(), BufferedImage.TYPE_INT_ARGB);
            Graphics2D gph = (Graphics2D) img.getGraphics();
            paintComponent(gph);
            gph.dispose();
            return img;

        }
        
        private void zoomIn() {
            //System.out.println("Zooming in");
            if(currentZ>maxZ) {
                return;
            }
            currentZ++;
            prezoom = paintToImg();
            zoomIn = true;
            
            centerX *= 2;
            offsetX *= 2;
            if(offsetX>=256) {
                offsetX--;
                centerX++;
            }
            
            centerY *= 2;
            offsetY *= 2;
            if(offsetY>=256) {
                offsetY--;
                centerY++;
            }
            MainFrame.this.repaint();
            zobrazAktualni();
        }
        
        private void zoomOut() {
            //System.out.println("Zooming out");
            if(currentZ<=minZ) {
                return;
            }
            currentZ--;
            
            prezoom = paintToImg();
            zoomIn = false;
            
            centerX /= 2;
            offsetX /= 2;
            
            centerY /= 2;
            offsetY /= 2;
            
            MainFrame.this.repaint();
            zobrazAktualni();
        }

        private void zobraz(int z, int x, int y) {
            currentZ = z;
            centerX = x;
            centerY = y;
            zobrazAktualni();
        }
        
        private void zobrazAktualni() {
            stackCurrent = 0;
            clearOffsets();
            clearImageLoading(); //zastavit predchozi nacitani
            for (int i = 0; i < 6; i++) {
                for (int j = 0; j < 6; j++) {
                    //images[i][j] = getImage(z, x + i - 1, y + j - 1);
                    startImageLoader(i, j, currentZ, centerX + i - 2, centerY + j - 2);
                }
            }
        }

        private void clearOffsets() {
            offsetX = offsetY = 0;
        }

        /**
         *
         * @param i index pole obrazku
         * @param j index pole obrazku
         * @param z souradnice
         * @param x souradnice
         * @param y souradnice
         */
        private ImageLoader startImageLoader(int i, int j, int z, int x, int y) {
            //System.out.println("registring..."+Math.random());
            ImageLoader il = new ImageLoader(i, j, z, x, y);
            Thread t = new Thread(il);
            t.setDaemon(true);
            t.start(); // samostatné vlákno
            imageLoaders.add(il);
            return il;
        }

        private void clearImageLoading() { //zastavit nacitani vsech predchozch obrazku
            while (!imageLoaders.isEmpty()) {
                imageLoaders.remove(0).stop();
            }
            //loaded = new boolean[6][6]; //all false
        }

        private String createURL(int z, int x, int y) {
            String url = "http://" + server + ":" + port + "/" + z + "/" + x + "/" + y + ".jpg";
            //System.out.println(url);
            return url;
        }

        private void incrementSpeed() {
            if (moveSpeed >= maxSpeed) {
                return;
            }
            moveSpeed *= 2;
            updateSpeed();
        }

        private void decrementSpeed() {
            if (moveSpeed <= minSpeed) {
                return;
            }
            moveSpeed /= 2;
            updateSpeed();
        }

        //update graphics
        private void updateSpeed() {
            moveField.setText(moveSpeed + "");
            MainFrame.this.repaint();
        }

        private void moveLeft() {
            offsetX += moveSpeed;
            if (offsetX >= 256) {
                offsetX -= 256;
                centerX--;
                moveImagesRight();
            }
            MainFrame.this.repaint();
        }

        private void moveUp() {
            offsetY += moveSpeed;
            if (offsetY >= 256) {
                offsetY -= 256;
                centerY--;
                moveImagesDown();
            }
            MainFrame.this.repaint();
        }

        private void moveDown() {
            offsetY -= moveSpeed;
            if (offsetY < 0) {
                offsetY += 256;
                centerY++;
                moveImagesUp();
            }
            MainFrame.this.repaint();
        }

        private void moveRight() {
            offsetX -= moveSpeed;
            if (offsetX < 0) {
                offsetX += 256;
                centerX++;
                moveImagesLeft();
            }
            MainFrame.this.repaint();
        }

        private void moveImagesRight() {
            for (ImageLoader il : imageLoaders) {
                il.move(1, 0); //načítání obrázků se poune taky
            }
            for (int j = 0; j < 6; j++) {
                Image im = null; //posovaci obrazek
                Image buff;
                for (int i = 0; i < 6; i++) {
                    //prohodit;
                    buff = im;
                    im = images[i][j];
                    images[i][j] = buff;
                }
                startImageLoader(0, j, currentZ, centerX - 2, centerY + j - 2);
            }
        }

        private void moveImagesDown() {

            for (ImageLoader il : imageLoaders) {
                il.move(0, 1); //načítání obrázků se poune taky
            }
            for (int i = 0; i < 6; i++) {
                Image im = null; //posovaci obrazek
                Image buff;
                for (int j = 0; j < 6; j++) {
                    //prohodit;
                    buff = im;
                    im = images[i][j];
                    images[i][j] = buff;
                }
                startImageLoader(i, 0, currentZ, centerX + i - 2, centerY - 2);
            }
        }

        private void moveImagesUp() {
            for (ImageLoader il : imageLoaders) {
                il.move(0, -1); //načítání obrázků se poune taky
            }
            for (int i = 0; i < 6; i++) {
                Image im = null; //posovaci obrazek
                Image buff;
                for (int j = 5; j >= 0; j--) {
                    //prohodit;
                    buff = im;
                    im = images[i][j];
                    images[i][j] = buff;
                }
                startImageLoader(i, 5, currentZ, centerX + i - 2, centerY + 3);
            }
        }

        private void moveImagesLeft() {
            for (ImageLoader il : imageLoaders) {
                il.move(-1, 0); //načítání obrázků se poune taky
            }
            for (int j = 0; j < 6; j++) {
                Image im = null; //posovaci obrazek
                Image buff;
                for (int i = 5; i >= 0; i--) {
                    //prohodit;
                    buff = im;
                    im = images[i][j];
                    images[i][j] = buff;
                }
                startImageLoader(5, j, currentZ, centerX + 3, centerY + j - 2);
            }
        }

        private class ImageLoader implements Runnable { //v jiném vlákně

            private volatile boolean stop = false; //nasaveno z hlavniho vlakna
            private volatile int i, j;
            private final int z, x, y;

            @Override
            public String toString() {
                return "ImageLoader{" + "i=" + i + ", j=" + j + ", z=" + z + ", x=" + x + ", y=" + y + '}';
            }

            /**
             *
             * @param i index pole obrazku
             * @param j index pole obrazku
             * @param z souradnice
             * @param x souradnice
             * @param y souradnice
             */
            public ImageLoader(int i, int j, int z, int x, int y) {
                this.i = i;
                this.j = j;
                this.z = z;
                this.x = x;
                this.y = y;
                //System.out.println("Registred " + this);
            }

            public void run() {
                //System.out.println("running " + this);
                try {
                    Image img = ImageIO.read(new URL(createURL(z, x, y)));
                    if (stop) {
                        return;
                    }
                    try {
                        images[i][j] = img;
                        stackCurrent++;
                        if(stackCurrent>=stackMax) {
                            prezoom = null; //smazat pozadi po nekolika strankach
                        }
                        //System.out.println("Přiřazuji na " + i + " " + j + " " + Math.random());
                    } catch (ArrayIndexOutOfBoundsException ex) {
                        //jak se pousouvá to navážení, prostě sh*t happens
                    }
                    //loaded[i][j] = true;
                    MainFrame.this.repaint();
                } catch (IOException ex) {
                    //Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
                }

            }

            private void move(int i, int j) { //change the position of img
                this.i += i;
                this.j += j;
            }

            private void stop() {
                stop = true;
            }
        }
    }

    private class MyDispatcher implements KeyEventDispatcher {

        @Override
        public boolean dispatchKeyEvent(KeyEvent e) {
            if (e.getID() == KeyEvent.KEY_PRESSED) {
                switch (e.getKeyCode()) {
                    case KeyEvent.VK_UP:
                        dp.moveUp();
                        break;
                    case KeyEvent.VK_RIGHT:
                        dp.moveRight();
                        break;
                    case KeyEvent.VK_DOWN:
                        dp.moveDown();
                        break;
                    case KeyEvent.VK_LEFT:
                        dp.moveLeft();
                        break;
                    case KeyEvent.VK_CONTROL:
                        dp.zoomIn();
                        break;
                    case KeyEvent.VK_SHIFT:
                        dp.zoomOut();
                        break;
                }
            } else if (e.getID() == KeyEvent.KEY_RELEASED) {
            } else if (e.getID() == KeyEvent.KEY_TYPED) {
            }
            return false;
        }
    }

    private class IncrementDecrementMoveListener implements ActionListener {

        public void actionPerformed(ActionEvent e) {
            Object o = e.getSource();
            if (o == incrementMove) {
                dp.incrementSpeed();
            } else if (o == decrementMove) {
                dp.decrementSpeed();
            } else {
                System.err.println("Uknow source: " + o);
                Thread.dumpStack(); //vypis chyby
            }
        }
    }

    private class ZobrazActionListener implements ActionListener {

        @Override
        public void actionPerformed(ActionEvent e) {
            zobrazPressed();
        }
    }
}
